package com.pwt.netty.handler;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToByteEncoder;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
@Slf4j
public class ModbusRequestEncoder extends MessageToByteEncoder<ByteBuf> {
    @Override
    protected void encode(ChannelHandlerContext ctx, ByteBuf msg, ByteBuf out) {
        log.info("处理器2启动");
        List<Byte> resulte = new ArrayList<>();
        while (msg.isReadable()) {
            resulte.add(msg.readByte());
        }
        Byte[] bytes = resulte.toArray(new Byte[0]);
        for (Byte b:bytes){
            log.info("收到设备回传报文========="+String.valueOf(b));
        }
        out.writeBytes(msg);
    }
}
