package com.pwt.web.controller;

import com.pwt.common.utils.spring.SpringUtils;
import com.pwt.framework.config.ThreadPoolConfig;
import com.pwt.netty.client.DianBiaoClient;
import com.pwt.netty.client.ModbusTcpClient;
import com.pwt.netty.config.NettyConfig;
import com.pwt.web.domain.DianBiaoData;
import com.pwt.web.service.impl.DianBiaoDataServiceImpl;
import lombok.extern.slf4j.Slf4j;
import lombok.val;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import static com.pwt.netty.util.CRChiUtil.crc16;

@RestController
@RequestMapping("dianbiao")
@Validated
@Slf4j
public class DianBiaoController {

//    @Value("${dianbiao.ipOne:192.168.3.52}")
    private String ipOne = "192.168.3.52";

//    @Value("${dianbiao.portOne:502}")
    private int portOne = 502;

    private String deviceNameOne = "2000kva";

//    @Value("${dianbiao.ipTwo:192.168.3.52}")
    private String ipTwo = "192.168.3.52";

//    @Value("${dianbiao.portTwo:503}")
    private int portTwo = 503;

    private String deviceNameTwo = "800kva";

//    @Value("${dianbiao.ipThree:127.0.0.1}")
    private String ipThree;

//    @Value("${dianbiao.portThree:502}")
    private int portThree ;

    private String deviceNameThree = "";

//    @Value("${dianbiao.ipFour:127.0.0.1}")
    private String ipFour ;

//    @Value("${dianbiao.portFour:502}")
    private int portFour;

    private String deviceNameFour = "";

//    @Value("${dianbiao.ipFive:127.0.0.1}")
    private String ipFive;

//    @Value("${dianbiao.portFive:502}")
    private int portFive;

    private String deviceNameFivr = "";

//    @Value("${dianbiao.ipSix:127.0.0.1}")
    private String ipSix;

//    @Value("${dianbiao.portSix:502}")
    private int portSix;

    private String deviceNameSix = "";

//    @Value("${dianbiao.ipSeven:127.0.0.1}")
    private String ipSeven;

//    @Value("${dianbiao.portSeven:502}")
    private int portSeven;

    private String deviceNameSeven = "";

//    @Value("${dianbiao.ipEight:127.0.0.1}")
    private String ipEight;

//    @Value("${dianbiao.portEight:502}")
    private int portEight;

    private String deviceNameEight = "";

    @Autowired
    private DianBiaoClient dianBiaoClient;

//    @Resource
//    private ThreadPoolConfig threadPoolTaskExecutor;

    public static void main(String[] args) {
        new DianBiaoController().connect();
    }

//    @PostMapping("connect")
    @Scheduled(fixedRate = 5000)
    public void connect() {
        ExecutorService executor = Executors.newFixedThreadPool(8);
        //设备一连接开启
        executor.submit(new Runnable() {
            @Override
            public void run() {
                ModbusTcpClient modbusTcpClient = new ModbusTcpClient();
                modbusTcpClient.startClient(ipOne, portOne, deviceNameOne,true);
                modbusTcpClient.startClient(ipOne, portOne, deviceNameOne,false);
                //设备一连接开启

            }
        });

        executor.submit(new Runnable() {
            @Override
            public void run() {
                //设备二连接开启
                ModbusTcpClient modbusTcpClient = new ModbusTcpClient();
                modbusTcpClient.startClient(ipTwo, portTwo,deviceNameTwo,false);
                modbusTcpClient.startClient(ipTwo, portTwo,deviceNameTwo,true);
            }
        });


//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备三连接开启
//                dianBiaoClient.startClient(ipThree, portThree,false);
//                dianBiaoClient.startClient(ipThree, portThree,true);
//            }
//        });
//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备四连接开启
//                dianBiaoClient.startClient(ipFour, portFour,false);
//                dianBiaoClient.startClient(ipFour, portFour,true);
//            }
//        });
//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备五连接开启
//                dianBiaoClient.startClient(ipFive, portFive,false);
//                dianBiaoClient.startClient(ipFive, portFive,true);
//            }
//        });
//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备六连接开启
//                dianBiaoClient.startClient(ipSix, portSix,false);
//                dianBiaoClient.startClient(ipSix, portSix,true);
//            }
//        });
//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备七连接开启
//                dianBiaoClient.startClient(ipSeven, portSeven,false);
//                dianBiaoClient.startClient(ipSeven, portSeven,true);
//            }
//        });
//        executor.submit(new Runnable() {
//            @Override
//            public void run() {
//                //设备八连接开启
//                dianBiaoClient.startClient(ipEight, portEight,false);
//                dianBiaoClient.startClient(ipEight, portEight,true);
//            }
//        });
        // 关闭线程池
        executor.shutdown();
        while (!executor.isTerminated()) {
        }
    }
}
