package com.pwt.web.domain;

import lombok.Builder;
import lombok.Data;

@Data
public class DianBiaoData {

    private String ip;
    //设备名称
    private String deviceName;
    //    A相相电压
    private Long aphaseVoltage;
    //    B相相电压
    private Long bphaseVoltage;
    //    C相相电压
    private Long cphaseVoltage;
    //    A-B线电压
    private Long abLineVoltage;
    //    B-C线电压
    private Long bcLineVoltage;

    public Long getAphaseCurrent() {
        return aphaseCurrent;
    }

    public void setAphaseCurrent(Long aphaseCurrent) {
        this.aphaseCurrent = (long) ((float) aphaseCurrent*0.8);
    }

    public Long getBphaseCurrent() {
        return bphaseCurrent;
    }

    public void setBphaseCurrent(Long bphaseCurrent) {
        this.bphaseCurrent =  (long) ((float) bphaseCurrent*0.8);
    }

    public Long getCphaseCurrent() {
        return cphaseCurrent;
    }

    public void setCphaseCurrent(Long cphaseCurrent) {
        this.cphaseCurrent = (long) ((float) cphaseCurrent*0.8);
    }

    //    C-A线电压
    private Long caLineVoltage;
    //    A相电流
    private Long aphaseCurrent;
    //    B相电流
    private Long bphaseCurrent;
    //    C相电流
    private Long cphaseCurrent;
    // A相有功功率
    private float aphaseActivePower;
    // B相有功功率
    private float bphaseActivePower;
    // C相有功功率
    private float cphaseActivePower;
    // 总相有功功率
    private float tphaseActivePower;
    // A相无功功率
    private float phaseAreactivePower;
    // B相无功功率
    private float phaseBreactivePower;
    // C相无功功率
    private float phaseCreactivePower;
    // 总相无功功率
    private float phaseTreactivePower;
    // A相视在功率
    private float alookEachPower;
    // B相视在功率
    private float blookEachPower;
    // C相视在功率
    private float clookEachPower;
    // 总相视在功率
    private float tlookEachPower;
    // 正向有功电能
    private Long positiveActiveEnergy;
    // 反向有功电能
    private Long reverseActiveEnergy;
    // 正向无功电能
    private Long forwardReactiveEnergy;
    // 反向无功电能
    private Long reverseReactiveEnergy;
    // 总有功电能（绝对值）
    private Long totalActivePower;
    // 总无功电能（绝对值）
    private Long totalReactivePower;



    public DianBiaoData(String ip) {
        this.ip = ip;
    }

    public DianBiaoData() {
    }

    @Override
    public String toString() {
        return "DianBiaoData{" +
                "ip='" + ip + '\'' +
                ", deviceName='" + deviceName + '\'' +
                ", aphaseVoltage=" + aphaseVoltage +
                ", bphaseVoltage=" + bphaseVoltage +
                ", cphaseVoltage=" + cphaseVoltage +
                ", abLineVoltage=" + abLineVoltage +
                ", bcLineVoltage=" + bcLineVoltage +
                ", caLineVoltage=" + caLineVoltage +
                ", aphaseCurrent=" + aphaseCurrent +
                ", bphaseCurrent=" + bphaseCurrent +
                ", cphaseCurrent=" + cphaseCurrent +
                ", aphaseActivePower=" + aphaseActivePower +
                ", bphaseActivePower=" + bphaseActivePower +
                ", cphaseActivePower=" + cphaseActivePower +
                ", tphaseActivePower=" + tphaseActivePower +
                ", phaseAreactivePower=" + phaseAreactivePower +
                ", phaseBreactivePower=" + phaseBreactivePower +
                ", phaseCreactivePower=" + phaseCreactivePower +
                ", phaseTreactivePower=" + phaseTreactivePower +
                ", alookEachPower=" + alookEachPower +
                ", blookEachPower=" + blookEachPower +
                ", clookEachPower=" + clookEachPower +
                ", tlookEachPower=" + tlookEachPower +
                ", positiveActiveEnergy=" + positiveActiveEnergy +
                ", reverseActiveEnergy=" + reverseActiveEnergy +
                ", forwardReactiveEnergy=" + forwardReactiveEnergy +
                ", reverseReactiveEnergy=" + reverseReactiveEnergy +
                ", totalActivePower=" + totalActivePower +
                ", totalReactivePower=" + totalReactivePower +
                '}';
    }
}
