package com.pwt.web.mapper;

import com.pwt.web.domain.DianBiaoData;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface DianBiaoDataMapper {

    /**
     * 查询电表数据
     *
     * @param
     * @return
     */
    @Select("select\n" +
            "            ip                      as    ip                   ,\n" +
            "            device_name             as    deviceName           ,\n" +
            "            aphase_voltage          as    aphaseVoltage        ,\n" +
            "            bphase_voltage          as    bphaseVoltage        ,\n" +
            "            cphase_voltage          as    cphaseVoltage        ,\n" +
            "            abLine_voltage          as    abLineVoltage        ,\n" +
            "            bcLine_voltage          as    bcLineVoltage        ,\n" +
            "            caLine_voltage          as    caLineVoltage        ,\n" +
            "            aphase_current          as    aphaseCurrent        ,\n" +
            "            bphase_current          as    bphaseCurrent        ,\n" +
            "            cphase_current          as    cphaseCurrent        ,\n" +
            "            aphase_active_power     as    aphaseActivePower    ,\n" +
            "            bphase_active_power     as    bphaseActivePower    ,\n" +
            "            cphase_active_power     as    cphaseActivePower    ,\n" +
            "            tphase_active_power     as    tphaseActivePower    ,\n" +
            "            phase_areactive_power   as    phaseAreactivePower  ,\n" +
            "            phase_breactive_power   as    phaseBreactivePower  ,\n" +
            "            phase_creactive_power   as    phaseCreactivePower  ,\n" +
            "            phase_treactive_power   as    phaseTreactivePower  ,\n" +
            "            alook_each_power        as    alookEachPower       ,\n" +
            "            blook_each_power        as    blookEachPower       ,\n" +
            "            clook_each_power        as    clookEachPower       ,\n" +
            "            tlook_each_power        as    tlookEachPower       ,\n" +
            "            positive_active_energy  as    positiveActiveEnergy ,\n" +
            "            reverse_active_energy   as    reverseActiveEnergy  ,\n" +
            "            forward_reactive_energy as    forwardReactiveEnergy,\n" +
            "            reverse_reactive_energy as    reverseReactiveEergy ,\n" +
            "            total_active_power      as    totalActivePower     ,\n" +
            "            total_reactive_power   as     totalReactivePower    \n" +
            "        from dian_biao_data")
    List<DianBiaoData> selectAll();

    /**
     * 查询电表数据
     *
     * @param
     * @return
     */
    DianBiaoData selectByIp(String ip);

    /**
     * 修改电表数据
     *
     * @param
     * @return
     */
    void updateDianBiaoData(DianBiaoData data);

    /**
     * 新增电表数据
     *
     * @param
     * @return
     */
    void insertDianBiaoData(DianBiaoData data);
}
