package com.pwt.web.service.impl;

import com.pwt.netty.message2.SystemPower;
import com.pwt.web.domain.DianBiaoData;
import com.pwt.web.mapper.DianBiaoDataMapper;
import com.pwt.web.service.IDianBiaoDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional(rollbackFor = Exception.class)
public class DianBiaoDataServiceImpl implements IDianBiaoDataService {

    @Autowired
    private DianBiaoDataMapper dianBiaoDataMapper;

    @Override
    public List<DianBiaoData> selectAll() {
        return dianBiaoDataMapper.selectAll();
    }

    @Override
    public DianBiaoData selectByIp(String ip) {
        return dianBiaoDataMapper.selectByIp(ip);
    }

    @Override
    public void updateDianBiaoData(DianBiaoData data) {
        dianBiaoDataMapper.updateDianBiaoData(data);
    }

    @Override
    public void insertDianBiaoData(DianBiaoData data) {
        dianBiaoDataMapper.insertDianBiaoData(data);
    }

    /**
     * 信息汇总中的 电表指针动态展示数据 数据从电表界面拿
     * @return
     */
    @Override
    public SystemPower initSystemPower() {
        List<DianBiaoData> datas = dianBiaoDataMapper.selectAll();
        DianBiaoData dianBiaoData = datas.get(0);
        SystemPower systemPower = new SystemPower();
        systemPower.setPower((int) dianBiaoData.getTphaseActivePower());
        systemPower.setVoltage((int)(dianBiaoData.getAphaseVoltage()+dianBiaoData.getBphaseVoltage()+dianBiaoData.getCphaseVoltage())/3);
        systemPower.setCurrent((int)(dianBiaoData.getAphaseCurrent()+dianBiaoData.getBphaseCurrent()+dianBiaoData.getCphaseCurrent())/3);
        return systemPower;
    }
}
